<?php








class ValueaddComponent extends CollectionComponent
{
 
 function ValueaddComponent( $valueLabel, $keyLabel=FALSE )
 {
 parent::CollectionComponent();
 $useKey = $keyLabel !== FALSE;
 $this->d_values["useKey"] = $useKey;
 
 if ( $useKey )
 {
 $this->setComponent( "ki", new TextComponent( $keyLabel, TRUE ) );
 }
 $this->setComponent( "vi", new TextAreaComponent( $valueLabel, TRUE, "", REG_TEXT, FALSE, array(1,5,10), array(30,30,40) ) );

 $itemlist = new ItemList3( "valadd", $this->_createDS() );
 $sel = new ItemListComponent( NULL, $itemlist );
 $sel->setWidth( "400px" );
 $this->setComponent( "s", $sel );
 $this->d_values["page"] = 1; 
 }
 
 function &_createDS() 
 {
 $ds = new ArrayDatasource( array(), array( "lname"=>i18n( "sName" ), "fvalue"=>i18n( "sValue" ) ) );
 $ds->addColumnAttribs( "lname", "width=100px" );
 $ds->addFormatter( "fvalue", new HtmlEntitiesFormatter( "value" ) );
 return $ds;
 }

 function replaceValue( $id, $name, $value )
 {
 $selc =& $this->getComponent( "s" );
 $sel =& $selc->getDatasource();
 $this->d_values["list"][$id]["name"] = $name;
 $this->d_values["list"][$id]["value"] = $value;
 $sel->replaceItem( $id, array("id"=>$id, "name"=>$name, "value"=>$value ) );
 }
 
 function addValue( $id, $value )
 {
 $selc =& $this->getComponent( "s" );
 $sel =& $selc->getDatasource();
 
 $this->d_values["list"][$id] = $value;
 $sel->setItem( $id, array("id"=>$id, "name"=>$value["name"], "value"=>$value["value"] ) );
 }
 
 function getValue( $id )
 {
 return $this->d_values["list"][$id];
 }
 
 function removeValue( $id )
 {
 $selc =& $this->getComponent( "s" );
 $sel =& $selc->getDatasource();
 $sel->removeItem( $id );
 unset( $this->d_values["list"][$id] );
 }
 
 function setList( $list, $maxId=-1 )
 {
 foreach ( $list as $id=>$value )
 {
 if ( $id > $maxId ) $maxId = $id;
 $this->addValue($id, $value);
 }
 $this->d_values["maxid"] = $maxId;
 }
 
 function getList()
 {
 $selc =& $this->getComponent( "s" );
 $sel =& $selc->getDatasource();
 $opts = $sel->getItems();
 $ret = array();
 foreach ( $opts as $key=>$val )
 {
 $ret[$key] = $this->d_values["list"][$key];
 }
 return $ret;
 }
 
 function getMaxID() 
 {
 return $this->d_values["maxid"];
 }
 
 function _tryAdding( &$key, &$value, &$sel )
 {
 if ( $this->d_values["useKey"] )
 {
 $keyText = $key->getText();
 if ( strlen( $keyText ) == 0 )
 {
 $key->addError( new NodeException( i18n("You must specify a key.") ), FM_SEVERITY_ALWAYS );
 return;
 }
 }
 else
 $keyText = $sel->size(); 
 if ( strlen( $value->getText() ) == 0 )
 {
 $value->addError( new NodeException( i18n("You must specify a value.") ), FM_SEVERITY_ALWAYS );
 return;
 }
 $this->addValue( ++$this->d_values["maxid"], array( "name"=>$keyText, "value"=> $value->getText()) );
 if ( $this->d_values["useKey"] ) $key->setText( "" );
 $value->setText( "" );
 $this->d_values["page"] = 1;
 }

 function _tryReplacing( &$key, &$value, &$sel )
 {
 if ( $this->d_values["useKey"] )
 {
 $keyText = $key->getText();
 if ( strlen($keyText) == 0 )
 {
 $key->addError( new NodeException( i18n("You must specify a key.") ), FM_SEVERITY_ALWAYS );
 return;
 }
 }
 else
 $keyText = FALSE;
 if ( strlen($value->getText()) == 0 )
 {
 $value->addError( new NodeException( i18n("You must specify a value.") ), FM_SEVERITY_ALWAYS );
 return;
 }
 $this->replaceValue($this->d_values["editkey"], $keyText, $value->getText() );
 if ( $this->d_values["useKey"] ) $key->setText( "" );
 $value->setText( "" );
 $this->d_values["page"] = 1;
 }

 
 function resolveAction( &$form, &$action, $jsParam )
 {
 $name = $action->getName();
 $csel = &$this->getComponent( "s" );
 $sel =& $csel->getDatasource();
 if ( $this->d_values["useKey"] )
 $key =& $this->getComponent( "ki" );
 $value = &$this->getComponent( "vi" );
 switch ( $name )
 {
 case "cancel":
 $this->d_values["page"] = 1;
 break;
 case "add":
 if ( $this->d_values["page"] != 2 ) {
 $this->d_values["page"] = 2;
 $this->d_values["edittype"] = "add";
 if ( $this->d_values["useKey"] ) $key->setText( "" );
 $value->setText( "" );
 }
 else {
 $this->_tryAdding( $key, $value, $sel );
 }
 break;
 case "edit":
 if ( $this->d_values["page"] != 2 ) {
 $this->d_values["page"] = 2;
 $this->d_values["edittype"] = "edit";
 $this->d_values["editkey"] = $jsParam;
 $val = $this->getValue($jsParam);
 if ( $this->d_values["useKey"] )
 $key->setText( $val["name"] );
 $value->setText( $val["value"] );
 }
 break;
 case "xchange":
 $this->_tryReplacing( $key, $value, $sel );
 break;
 case "remove":
 $list =& $csel->getList();
 $selections = $list->getSelection();
 foreach ( $selections as $selection )
 {
 $this->removeValue($selection);
 }
 break;
 case "up":
 $list =& $csel->getList();
 $selections = $list->getSelection();
 $ds =& $list->getDatasource();
 foreach ( $selections as $selection )
 {
 $ds->moveItemUp($selection);
 }
 break;
 case "down":
 $list =& $csel->getList();
 $selections = array_reverse( $list->getSelection() );
 $ds =& $list->getDatasource();
 foreach ( $selections as $selection )
 {
 $ds->moveItemDown($selection);
 }
 break;
 }
 }
 
 




 function buttonsVisible()
 {
 return $this->d_values["page"] != 2;
 }
 
 function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $key )
 {
 global $ICO_BIGGER, $ICO_DELETE, $ICO_UP, $ICO_DOWN;
 global $ICO_ADD, $ICO_REPLACE, $ICO_EDIT;
 global $BUTTONURL;

 $BTN_ADD = new Button(i18n("OK"));
 $BTN_REPLACE = new Button( i18n("OK") );
 $BTN_CANCEL = new Button( i18n("Cancel") );
 $actionAdd = $form->getJsActionCall( new ComponentResolvableFormAction( $key, "add" ) );
 $actionRemove = $form->getJsActionCall( new ComponentResolvableFormAction( $key, "remove" ) );
 $actionCancel = $form->getJsActionCall( new ComponentResolvableFormAction( $key, "cancel" ) );
 $actionMoveUp = $form->getJsActionCall( new ComponentResolvableFormAction( $key, "up" ) );
 $actionMoveDown = $form->getJsActionCall( new ComponentResolvableFormAction( $key, "down" ) );
 $actionEdit = $form->getJsActionParamCall( new ComponentResolvableFormAction( $key, "edit" ) );
 $actionXChange = $form->getJsActionCall( new ComponentResolvableFormAction( $key, "xchange" ) );


 $add = $BTN_ADD->_getHtml( $actionAdd );
 $xChange = $BTN_REPLACE->_getHtml( $actionXChange );
 $cancel = $BTN_CANCEL->_getHtml( $actionCancel );

 $html = "<table border=0 width=100%>\n";

 
 if ( $this->d_values["page"] == 2 )
 {
 
 $connectedAction = ($this->d_values["edittype"]=="add")?$actionAdd:$actionXChange;
 $cKey =& $this->getComponent( "ki" );
 $cKey->setShortcut( VK_ENTER, $connectedAction );
 $cKey =& $this->getComponent( "vi" );
 $cKey->setShortcut( VK_ENTER, $connectedAction );
 $cKey->setShortcut( VK_ENTER | VK_MOD_CTRL, $connectedAction );

 
 if ( $this->d_values["useKey"] )
 {
 $ki = $this->_getComponentHTML( "ki", $form, $prefix, $doCheck, $checkSeverity, $key );
 $html .= $this->translateRows($ki);
 }
 else $html .= "<tr><td colspan=2>&nbsp;</td></tr>";
 
 $vi = $this->_getComponentHTML( "vi", $form, $prefix, $doCheck, $checkSeverity, $key );
 
 $html .= $this->translateRows( $vi );
 
 $html .= "<tr><td>&nbsp;</td><td align=right>";
 $html .= ($this->d_values["edittype"]=="add")?$add:$xChange;
 $html .= "&nbsp;".$cancel;
 $html .= "</td></tr>";
 }
 else
 {
 $cSel =& $this->getComponent( "s" );
 $ds =& $cSel->getDatasource();
 $ds->setAction( new JavascriptAction( $ICO_ADD, "add", i18n("Add Entry"), $actionAdd ) );
 $ds->setAction( new JavascriptAction( $ICO_DELETE, "remove", i18n("Remove Entry"), $actionRemove ) );
 $ds->setAction( new JavascriptAction( $ICO_UP, "up", i18n("Move Entry Up"), $actionMoveUp ) );
 $ds->setAction( new JavascriptAction( $ICO_DOWN, "down", i18n("Move Entry Down"), $actionMoveDown ) );
 $ds->makeJSLink( "lname", "name", $actionEdit, "", "id" );

 $sel = $this->_getComponentHTML( "s", $form, $prefix, $doCheck, $checkSeverity, $key );
 $html .= $this->translateRows( $sel );
 }
 $html .= "</table>";
 
 $rs = $this->mergeResult( parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $key ), $html );
 
 return $rs;
 }
}

?>
